
Redmine - Defect #13713

File attachment is broken with REST API XML format

2013-04-08 17:00 - TANUKI M

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

example case

POST /issues.xml

<issue>

  <project_id>1</project_id>

  <subject>Creating an issue with a uploaded file</subject>

  <uploads type="array">

    <upload>

      <token>7167.ed1ccdb093229ca1bd0b043618d88743</token>

      <filename>image.png</filename>

      <description>An optional description here</description>

      <content_type>image/png</content_type>

    </upload>

  </uploads>

</issue>

 in 'app/controllers/issues_controller.rb'

　　 params[:issue][:uploads] # => [{"upload"=>{"content_type"=>"image/png", "description"=>"An opti

onal description here", "filename"=>"image.png", "token"=>"7167.ed1ccdb093229ca1bd0b043618d88743"}

}}

 so, never be true in 'lib/plugins/acts_as_attachable/lib/acts_as_attachable.rb'

　              elsif token = attachment['token']

 attachment['upload']['token'] is true

History

#1 - 2013-04-09 09:53 - Etienne Massip

- Subject changed from REST API issue cannot attach files to File attachment is broken with REST API XML format

Which Redmine version? Any plugin installed?

#2 - 2013-04-09 15:02 - TANUKI M

My environment is as follows.

Environment:

  Redmine version                          2.3.0.devel.11710

  Ruby version                             1.9.3 (i686-linux)

  Rails version                            3.2.13

  Environment                              production

  Database adapter                         Mysql2

Redmine plugins:

  no plugin installed
#3 - 2013-04-09 19:09 - TANUKI M

Sorry, I'm afraid that this is my mistake.

I used ActiveResource for test.

require 'rubygems'

require 'active_resource'

class Issue < ActiveResource::Base

  self.site = 'http://localhost/redmine'

  self.user = 'rest'

  self.password = 'rest'

end

token = "7167.ed1ccdb093229ca1bd0b043618d88743" 

issue = Issue.new(

  :subject => 'REST API',

  :assigned_to_id => 1,

  :project_id => 1,

  :uploads => [ {"token" => token, "filename" => "test"} ]

)

puts "*** issue(before)" 

puts issue.to_xml

issue.save

 issue.to_xml

<?xml version="1.0" encoding="UTF-8"?>

<issue>

  <assigned-to-id type="integer">1</assigned-to-id>

  <project-id type="integer">1</project-id>

  <subject>REST API</subject>

  <uploads type="array">

    <upload>

      <id nil="true"></id>

      <token>7167.ed1ccdb093229ca1bd0b043618d88743</token>

    </upload>

  </uploads>

</issue>

 
  Parameters: {"issue"=>{"assigned_to_id"=>1, "project_id"=>1, "subject"=>"REST API", "uploads"=>[{"upload"=>{

"filename"=>"test", "token"=>"7167.ed1ccdb093229ca1bd0b043618d88743"}}]}}

 ok code is as follows.

#:

issue = Issue.new(

  :subject => 'REST API',

  :assigned_to_id => 1,

  :project_id => 1

)

issue.uploads = [ {"token" => token, "filename" => "test"} ]

#:

 
  Parameters: {"issue"=>{"assigned_to_id"=>1, "project_id"=>1, "subject"=>"REST API", "uploads"=>[{"token"=>"7

167.ed1ccdb093229ca1bd0b043618d88743", "filename"=>"test"}]}}

 parameter "uploads" is different

#4 - 2013-04-09 19:23 - Etienne Massip

Can you confirm I can close the issue?

What gives issue.to_xml in the working example?

#5 - 2013-04-10 12:40 - TANUKI M

Etienne Massip wrote:
Can you confirm I can close the issue?

 Please close.

What gives issue.to_xml in the working example?

 same xml...

<?xml version="1.0" encoding="UTF-8"?>

<issue>

  <assigned-to-id type="integer">1</assigned-to-id>

  <project-id type="integer">1</project-id>

  <subject>REST API</subject>

  <uploads type="array">

    <upload>

      <token>7167.ed1ccdb093229ca1bd0b043618d88743</token>

      <filename>test</filename>

    </upload>

  </uploads>

</issue>

#6 - 2013-04-10 12:41 - Daniel Felix

- Status changed from New to Closed

Closed by author demand. Thanks for your Feedback.
